<?php
/**
 * Created by PhpStorm.
 * User: tuliomagalhaes
 * Date: 14/03/17
 * Time: 09:56
 */

namespace Service\Event;

use Doctrine\Common\EventSubscriber;
use Doctrine\ORM\Event\LifecycleEventArgs;
use Doctrine\ORM\Events;
use Teknisa\Model\Teknisa\Events\AuditAble;
use Util\Utilities;


class Audit  implements EventSubscriber{

    public function prePersist(LifecycleEventArgs $args) {
        $entity = $args->getEntity();
        if ($entity instanceof AuditAble) {
            $environment = Utilities::getEnvironment();
            $nrorg = $environment->getCurrentOrganizationId();
            $userId = $environment->getCurrentCdoperador();
            if($userId && $nrorg) {
                $entity->setNrorginclusao($nrorg);
                $entity->setNrorgultatu($nrorg);
                $entity->setCdoperinclusao($userId);
                $entity->setCdoperultatu($userId);
            }

            $currentTime = $environment->getCurrentTime();
            $entity->setDtinclusao($currentTime);
            $entity->setDtultatu($currentTime);
        }
    }

    public function preUpdate(LifecycleEventArgs $args) {
        $entity = $args->getEntity();
        if ($entity instanceof AuditAble) {
            $environment = Utilities::getEnvironment();
            $nrorg = $environment->getCurrentOrganizationId();
            $userId = $environment->getCurrentUserId();
            if($userId && $nrorg) {
                $entity->setNrorgultatu($nrorg);;
                $entity->setCdoperultatu($userId);
            }

            $currentTime = $environment->getCurrentTime();
            $entity->setDtultatu($currentTime);
        }
    }


    /**
     * Returns an array of events this subscriber wants to listen to.
     *
     * @return array
     */
    public function getSubscribedEvents() {
        return array(
            Events::prePersist,
            Events::preUpdate,
        );
    }

} 